// Telemetry.h : main header file for the Telemetry DLL
//

#pragma once

#include "decl.h"
#include "Engine/Module.h"
#include "Utils/SelectionInfo.h"
#include "Utils/ssp.h"
#include "Utils/Time.h"

// The global dll info structure.
extern AFX_EXTENSION_MODULE TelemetryDLL;

extern "C" LPCTSTR TELEMETRY_DECL GetTelemetryPath();
extern "C" LPCTSTR TELEMETRY_DECL GetTelemetryVersion();

typedef bool (* PERFORMBASICFORMAT) (bool& FormatResult, CString Name, CString Format, TData& Buffer, int Group);

// Example:
// Name: "GPRS"
// Format: "SelfTimed"
extern "C" PERFORMBASICFORMAT TELEMETRY_DECL g_PerformBasicFormat;

typedef CString (* SMSCOMMAND) (CString Cmd, CString UserName);

// Example:
// Cmd: "REDIR www.sutron.com:3003"
// UserName: "operator"
extern "C" SMSCOMMAND TELEMETRY_DECL g_SMSCommand;

// External method to invoke BUFR tag dialog. Sets up resource keys, as needed. 
extern int TELEMETRY_DECL BUFRTagDlg(CWnd *pParentWnd, CString& strDescriptor, int& eTxContent, 
                                     CString& strTime, CString& strInterval, int& iNumVals, int& iSequence, 
                                     TTimeSpan tsTxInterval, CString strSchedInterval, CString strSchedTime);
extern int TELEMETRY_DECL BUFRTagDlg(CWnd *pParentWnd, CString& strDescriptor, int& eTxContent, 
                                     CString& strTime, CString& strInterval, int& iNumVals, int& iSequence, 
                                     TTimeSpan tsTxInterval, CString strSchedInterval, CString strSchedTime, 
                                     TModule* pTag, BOOL &fAutoFindLog, CString &strLogFile, CString &strSensorName);

// External method to invoke BUFR options dialog. Sets up resource keys, as needed. 
extern int TELEMETRY_DECL BUFROptionsDlg(CWnd *pParentWnd, CString& strOriginatingCenter, 
                                         CString& strDataCategory, CString& strDataSubCategory);

// External method to invoke log options dialog. Sets up resource keys, as needed. 
extern int TELEMETRY_DECL LogFindOrSelectDlg(CWnd *pParentWnd, TModule* pTag, BOOL &fAutoFindLog, 
                                             CString &strLogFile, CString &strSensorName);

// Telemetry data content selection helpers
enum ETxContent {eAll, eIndividual, eLast, eExclude};
extern TELEMETRY_DECL TSelectionInfo g_siDataContent;